Public Class Form1
    ' List primes.
    Private Sub btnGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGo.Click
        ' Make an array big enough.
        Dim max As Integer = Integer.Parse(txtMaxNumber.Text)
        Dim is_prime(max) As Boolean

        ' Assume all of the odd numbers are prime.
        ' Ignore the even numbers.
        For i As Integer = 3 To max Step 2
            is_prime(i) = True
        Next i

        ' Use Euler's Sieve.
        ' See http://en.wikipedia.org/wiki/Sieve_of_Eratosthenes.
        Dim max_i As Integer = Int(Math.Sqrt(max) + 1)
        For i As Integer = 3 To max_i
            ' Only use i if it is prime.
            If (is_prime(i)) Then
                ' Decide where we need to stop.
                Dim max_j As Integer = max \ i
                If (max_j Mod 2 = 0) Then max_j -= 1 ' Make it odd.

                ' "Cross out" multiples of i starting
                ' with i * max_j and ending with i * i.
                For j As Integer = max_j To i Step -2
                    ' Only use j if it is prime.
                    If (is_prime(j)) Then
                        ' "Cross out" i * j.
                        is_prime(i * j) = False
                    End If
                Next j
            End If
        Next i

        ' Display the results.
        lstPrimes.Items.Clear()
        lstPrimes.Items.Add("2")
        For i As Integer = 3 To max Step 2
            If (is_prime(i)) Then lstPrimes.Items.Add(i.ToString())
        Next i

        ' Display the actual number of primes.
        lblActualPrimes.Text = lstPrimes.Items.Count.ToString()

        ' Display a Legendre estimate ?(n) = n/(log(n) - 1.08366).
        ' See http://mathworld.wolfram.com/PrimeCountingFunction.html.
        Dim est As Double = max / (Math.Log(max) - 1.08366)
        lblEstPrimes.Text = est.ToString("0")
    End Sub
End Class
